
// example presented in paragraph 7.14 of the manual
// https://maniFEM.rd.ciencias.ulisboa.pt/manual-maniFEM.pdf
// a sector of an annulus, repeated

#include "maniFEM.h"

using namespace maniFEM;


int main ( )

{	// begin with the usual two-dimensional space
	Manifold RR2 ( tag::Euclid, tag::of_dim, 2 );
	Function xy = RR2 .build_coordinate_system ( tag::Lagrange, tag::of_degree, 1 );
	Function x = xy[0], y = xy[1];

	const double theta = 1.,  // radians
		cos_theta = std::cos ( theta ), sin_theta = std::sin ( theta );
	
	// define an action on RR2 (a rotation)
	Manifold::Action rot ( tag::transforms, xy, tag::into,
		( cos_theta * x - sin_theta * y ) && ( sin_theta * x + cos_theta * y ) );

	// and divide RR2 by the group generated by rot
	Manifold torus_manif = RR2 .quotient ( rot );

	Cell A ( tag::vertex );  x(A) = 0.;  y(A) = 1.;
	Cell B ( tag::vertex );  x(B) = 0.;  y(B) = 2.;

	Mesh AA = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( A ) .divided_in ( 10 ) .winding ( -rot );
	Mesh AB = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( B ) .divided_in ( 7 );  // zero winding
	Mesh BB = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( B ) .stop_at ( B ) .divided_in ( 10 ) .winding ( rot );

	Mesh sector = Mesh::Build ( tag::grid ) .shape ( tag::rectangle )
		.faces ( AA, AB, BB, AB .reverse() ) .winding();

	// we can draw an unfolded mesh
	sector .export_to_file ( tag::eps, "sector.eps", tag::unfold, { -2*rot, -rot, 0, rot, 2*rot },
	                         tag::over_region, -2.1 < x < 2.1, -0.3 < y < 2.1                     );
	std::cout << "produced file sector.eps - please edit before viewing" << std::endl;

}  // end of main
